#
#  Copyright (c) 2007 Helmut Merz helmutm@cy55.de
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""
A dummy transport for testing purposes.

$Id$
"""

from twisted.internet import reactor
from twisted.internet.defer import Deferred
from zope.interface import implements

from loops.agent.interfaces import ITransportJob, ITransporter
from loops.agent.schedule import Job
from loops.agent.transport.base import TransportJob as BaseJob
from loops.agent.transport.base import Transporter as BaseTransporter


class TransportJob(BaseJob):

    def execute(self):
        kw = self.params
        result = kw.get('result')
        if result is None:
            print 'No data available.'
        else:
            for res, meta in result:
                d = self.transporter.transfer(res.data, meta)
        return Deferred()


class Transporter(BaseTransporter):

    jobFactory = TransportJob

    def transfer(self, data, metadata=None):
        if type(data) is file:
            text = data.read()
            data.close()
        else:
            text = data
        print 'Transferring:', text
        return Deferred()

